From 54faaa30643da0ad55c11b9b0c10b8b08c709051 Mon Sep 17 00:00:00 2001
From: Bertrand Drouvot <bertranddrouvot.pg@gmail.com>
Date: Sat, 15 Nov 2025 17:24:49 +0000
Subject: [PATCH v1 2/8] Use OidIsValid() in various places

Let's use OidIsValid() instead of:

- direct comparisons with InvalidOid
- direct comparisons with literal 0
---
 contrib/pg_overexplain/pg_overexplain.c       |  2 +-
 contrib/pg_prewarm/autoprewarm.c              |  6 +--
 .../pg_stat_statements/pg_stat_statements.c   |  8 ++--
 contrib/postgres_fdw/deparse.c                | 32 +++++++--------
 src/backend/access/brin/brin.c                |  2 +-
 src/backend/access/brin/brin_bloom.c          |  2 +-
 src/backend/access/brin/brin_inclusion.c      |  4 +-
 src/backend/access/brin/brin_minmax.c         |  2 +-
 src/backend/access/brin/brin_minmax_multi.c   |  6 +--
 src/backend/access/common/toast_internals.c   |  2 +-
 src/backend/access/gin/gininsert.c            |  2 +-
 src/backend/access/gin/ginutil.c              |  4 +-
 src/backend/access/gist/gistutil.c            |  4 +-
 src/backend/access/hash/hashfunc.c            |  4 +-
 src/backend/access/hash/hashsearch.c          |  2 +-
 src/backend/access/heap/heapam.c              |  2 +-
 src/backend/access/heap/heapam_visibility.c   | 16 ++++----
 src/backend/access/index/indexam.c            |  2 +-
 src/backend/access/nbtree/nbtcompare.c        |  2 +-
 src/backend/access/nbtree/nbtpreprocesskeys.c | 18 ++++-----
 src/backend/access/nbtree/nbtsearch.c         |  2 +-
 src/backend/access/table/tableamapi.c         |  2 +-
 src/backend/bootstrap/bootstrap.c             |  2 +-
 src/backend/catalog/aclchk.c                  |  3 +-
 src/backend/catalog/catalog.c                 |  2 +-
 src/backend/catalog/heap.c                    | 12 +++---
 src/backend/catalog/index.c                   |  2 +-
 src/backend/catalog/namespace.c               |  4 +-
 src/backend/catalog/objectaddress.c           |  4 +-
 src/backend/catalog/partition.c               |  2 +-
 src/backend/catalog/pg_aggregate.c            |  2 +-
 src/backend/catalog/pg_inherits.c             |  4 +-
 src/backend/catalog/pg_operator.c             |  6 +--
 src/backend/catalog/pg_shdepend.c             |  2 +-
 src/backend/catalog/pg_tablespace.c           |  2 +-
 src/backend/catalog/toasting.c                |  2 +-
 src/backend/commands/aggregatecmds.c          |  2 +-
 src/backend/commands/cluster.c                |  2 +-
 src/backend/commands/copyto.c                 |  2 +-
 src/backend/commands/event_trigger.c          |  2 +-
 src/backend/commands/extension.c              |  2 +-
 src/backend/commands/functioncmds.c           |  4 +-
 src/backend/commands/indexcmds.c              | 12 +++---
 src/backend/commands/sequence.c               |  4 +-
 src/backend/commands/statscmds.c              |  6 +--
 src/backend/commands/tablecmds.c              | 22 +++++-----
 src/backend/commands/tablespace.c             |  8 ++--
 src/backend/commands/trigger.c                |  2 +-
 src/backend/commands/typecmds.c               | 18 ++++-----
 src/backend/commands/vacuum.c                 |  2 +-
 src/backend/commands/view.c                   |  2 +-
 src/backend/executor/execUtils.c              |  2 +-
 src/backend/executor/functions.c              |  2 +-
 src/backend/nodes/nodeFuncs.c                 |  8 ++--
 src/backend/optimizer/path/costsize.c         |  4 +-
 src/backend/optimizer/path/indxpath.c         |  6 +--
 src/backend/optimizer/path/joinpath.c         |  2 +-
 src/backend/optimizer/prep/prepqual.c         |  4 +-
 src/backend/optimizer/util/plancat.c          | 20 +++++-----
 src/backend/parser/parse_clause.c             |  2 +-
 src/backend/parser/parse_coerce.c             |  6 +--
 src/backend/parser/parse_expr.c               |  6 +--
 src/backend/parser/parse_oper.c               | 10 ++---
 src/backend/parser/parse_target.c             |  2 +-
 src/backend/parser/parse_type.c               |  2 +-
 src/backend/parser/parse_utilcmd.c            |  4 +-
 .../libpqwalreceiver/libpqwalreceiver.c       |  2 +-
 src/backend/replication/logical/decode.c      |  2 +-
 src/backend/replication/logical/logical.c     |  2 +-
 src/backend/replication/logical/relation.c    |  4 +-
 .../replication/logical/reorderbuffer.c       |  4 +-
 src/backend/replication/pgoutput/pgoutput.c   |  2 +-
 src/backend/replication/slot.c                |  4 +-
 src/backend/replication/slotfuncs.c           |  6 +--
 src/backend/replication/walsender.c           |  8 ++--
 src/backend/rewrite/rewriteHandler.c          |  2 +-
 src/backend/statistics/dependencies.c         |  2 +-
 src/backend/statistics/mcv.c                  |  2 +-
 src/backend/statistics/mvdistinct.c           |  2 +-
 src/backend/storage/buffer/bufmgr.c           |  2 +-
 src/backend/storage/file/fd.c                 |  4 +-
 src/backend/storage/ipc/procarray.c           |  4 +-
 src/backend/storage/lmgr/lock.c               |  2 +-
 src/backend/storage/lmgr/predicate.c          |  2 +-
 src/backend/tcop/postgres.c                   |  2 +-
 src/backend/tsearch/ts_parse.c                |  2 +-
 src/backend/utils/activity/pgstat.c           |  2 +-
 src/backend/utils/adt/array_selfuncs.c        |  2 +-
 src/backend/utils/adt/array_userfuncs.c       |  4 +-
 src/backend/utils/adt/enum.c                  |  8 ++--
 src/backend/utils/adt/format_type.c           |  4 +-
 src/backend/utils/adt/json.c                  | 10 ++---
 src/backend/utils/adt/jsonb.c                 | 10 ++---
 src/backend/utils/adt/like_support.c          |  2 +-
 src/backend/utils/adt/misc.c                  |  8 ++--
 .../utils/adt/multirangetypes_selfuncs.c      |  2 +-
 src/backend/utils/adt/network.c               |  4 +-
 src/backend/utils/adt/pgstatfuncs.c           |  4 +-
 src/backend/utils/adt/rangetypes_selfuncs.c   |  2 +-
 src/backend/utils/adt/regproc.c               | 20 +++++-----
 src/backend/utils/adt/ruleutils.c             |  4 +-
 src/backend/utils/adt/selfuncs.c              |  8 ++--
 src/backend/utils/adt/varchar.c               |  4 +-
 src/backend/utils/cache/inval.c               | 14 +++----
 src/backend/utils/cache/lsyscache.c           |  2 +-
 src/backend/utils/cache/plancache.c           |  6 +--
 src/backend/utils/cache/relfilenumbermap.c    |  4 +-
 src/backend/utils/cache/spccache.c            |  2 +-
 src/backend/utils/cache/ts_cache.c            |  2 +-
 src/backend/utils/cache/typcache.c            | 40 +++++++++----------
 src/backend/utils/fmgr/funcapi.c              |  2 +-
 src/backend/utils/misc/queryenvironment.c     |  2 +-
 src/bin/pg_dump/common.c                      |  2 +-
 src/bin/pg_dump/pg_backup_archiver.c          |  2 +-
 src/bin/pg_dump/pg_backup_custom.c            |  6 +--
 src/bin/pg_dump/pg_backup_null.c              |  2 +-
 src/bin/pg_dump/pg_backup_tar.c               |  4 +-
 src/bin/pg_dump/pg_dump.c                     | 24 +++++------
 src/bin/pg_resetwal/pg_resetwal.c             |  6 +--
 src/bin/psql/describe.c                       |  2 +-
 src/bin/psql/large_obj.c                      |  2 +-
 src/common/relpath.c                          |  4 +-
 src/interfaces/libpq/fe-lobj.c                | 30 +++++++-------
 src/pl/plperl/plperl.c                        | 12 +++---
 src/pl/plpgsql/src/pl_exec.c                  |  4 +-
 src/pl/plpython/plpy_procedure.c              |  2 +-
 src/pl/plpython/plpy_typeio.c                 |  8 +---
 src/test/examples/testlo.c                    |  4 +-
 src/test/examples/testlo64.c                  |  4 +-
 129 files changed, 346 insertions(+), 349 deletions(-)
   3.8% contrib/postgres_fdw/
   3.3% src/backend/access/brin/
   8.4% src/backend/access/
   7.5% src/backend/catalog/
  15.7% src/backend/commands/
   3.0% src/backend/optimizer/util/
   4.5% src/backend/parser/
   4.6% src/backend/replication/
   9.9% src/backend/utils/adt/
  11.3% src/backend/utils/cache/
   9.4% src/backend/
   4.3% src/bin/pg_dump/
   4.1% src/interfaces/libpq/
   4.7% src/pl/

diff --git a/contrib/pg_overexplain/pg_overexplain.c b/contrib/pg_overexplain/pg_overexplain.c
index bd70b6d9d5e..ebf8109ec84 100644
--- a/contrib/pg_overexplain/pg_overexplain.c
+++ b/contrib/pg_overexplain/pg_overexplain.c
@@ -479,7 +479,7 @@ overexplain_range_table(PlannedStmt *plannedstmt, ExplainState *es)
 		 * displayed only in verbose mode, and we emit nothing if there is no
 		 * relation OID.
 		 */
-		if (rte->relid != 0)
+		if (OidIsValid(rte->relid))
 		{
 			const char *relname;
 			const char *qualname;
diff --git a/contrib/pg_prewarm/autoprewarm.c b/contrib/pg_prewarm/autoprewarm.c
index 5ba1240d51f..837fe43f937 100644
--- a/contrib/pg_prewarm/autoprewarm.c
+++ b/contrib/pg_prewarm/autoprewarm.c
@@ -398,7 +398,7 @@ apw_load_buffers(void)
 				 * Combine BlockInfoRecords for global objects with those of
 				 * the database.
 				 */
-				if (current_db != InvalidOid)
+				if (OidIsValid(current_db))
 					break;
 				current_db = blkinfo[j].database;
 			}
@@ -411,7 +411,7 @@ apw_load_buffers(void)
 		 * BlockInfoRecords belonging to global objects exist.  We can't
 		 * prewarm without a database connection, so just bail out.
 		 */
-		if (current_db == InvalidOid)
+		if (!OidIsValid(current_db))
 			break;
 
 		/* Configure stop point and database for next per-database worker. */
@@ -536,7 +536,7 @@ autoprewarm_database_main(Datum main_arg)
 		 * All blocks between prewarm_start_idx and prewarm_stop_idx should
 		 * belong either to global objects or the same database.
 		 */
-		Assert(blk.database == apw_state->database || blk.database == 0);
+		Assert(blk.database == apw_state->database || !OidIsValid(blk.database));
 
 		StartTransactionCommand();
 
diff --git a/contrib/pg_stat_statements/pg_stat_statements.c b/contrib/pg_stat_statements/pg_stat_statements.c
index 39208f80b5b..83ac02f2f0e 100644
--- a/contrib/pg_stat_statements/pg_stat_statements.c
+++ b/contrib/pg_stat_statements/pg_stat_statements.c
@@ -2730,7 +2730,7 @@ entry_reset(Oid userid, Oid dbid, int64 queryid, bool minmax_only)
 
 	stats_reset = GetCurrentTimestamp();
 
-	if (userid != 0 && dbid != 0 && queryid != INT64CONST(0))
+	if (OidIsValid(userid) && OidIsValid(dbid) && queryid != INT64CONST(0))
 	{
 		/* If all the parameters are available, use the fast path. */
 		memset(&key, 0, sizeof(pgssHashKey));
@@ -2753,14 +2753,14 @@ entry_reset(Oid userid, Oid dbid, int64 queryid, bool minmax_only)
 
 		SINGLE_ENTRY_RESET(entry);
 	}
-	else if (userid != 0 || dbid != 0 || queryid != INT64CONST(0))
+	else if (OidIsValid(userid) || OidIsValid(dbid) || queryid != INT64CONST(0))
 	{
 		/* Reset entries corresponding to valid parameters. */
 		hash_seq_init(&hash_seq, pgss_hash);
 		while ((entry = hash_seq_search(&hash_seq)) != NULL)
 		{
-			if ((!userid || entry->key.userid == userid) &&
-				(!dbid || entry->key.dbid == dbid) &&
+			if ((!OidIsValid(userid) || entry->key.userid == userid) &&
+				(!OidIsValid(dbid) || entry->key.dbid == dbid) &&
 				(!queryid || entry->key.queryid == queryid))
 			{
 				SINGLE_ENTRY_RESET(entry);
diff --git a/contrib/postgres_fdw/deparse.c b/contrib/postgres_fdw/deparse.c
index f2fb0051843..f2b8968c189 100644
--- a/contrib/postgres_fdw/deparse.c
+++ b/contrib/postgres_fdw/deparse.c
@@ -367,7 +367,7 @@ foreign_expr_walker(Node *node,
 				{
 					/* Var belongs to some other table */
 					collation = var->varcollid;
-					if (collation == InvalidOid ||
+					if (!OidIsValid(collation) ||
 						collation == DEFAULT_COLLATION_OID)
 					{
 						/*
@@ -472,7 +472,7 @@ foreign_expr_walker(Node *node,
 				 * non-collation-sensitive context.
 				 */
 				collation = c->constcollid;
-				if (collation == InvalidOid ||
+				if (!OidIsValid(collation) ||
 					collation == DEFAULT_COLLATION_OID)
 					state = FDW_COLLATE_NONE;
 				else
@@ -503,7 +503,7 @@ foreign_expr_walker(Node *node,
 				 * Collation rule is same as for Consts and non-foreign Vars.
 				 */
 				collation = p->paramcollid;
-				if (collation == InvalidOid ||
+				if (!OidIsValid(collation) ||
 					collation == DEFAULT_COLLATION_OID)
 					state = FDW_COLLATE_NONE;
 				else
@@ -543,7 +543,7 @@ foreign_expr_walker(Node *node,
 				 * function nodes.
 				 */
 				collation = sr->refcollid;
-				if (collation == InvalidOid)
+				if (!OidIsValid(collation))
 					state = FDW_COLLATE_NONE;
 				else if (inner_cxt.state == FDW_COLLATE_SAFE &&
 						 collation == inner_cxt.collation)
@@ -577,7 +577,7 @@ foreign_expr_walker(Node *node,
 				 * If function's input collation is not derived from a foreign
 				 * Var, it can't be sent to remote.
 				 */
-				if (fe->inputcollid == InvalidOid)
+				if (!OidIsValid(fe->inputcollid))
 					 /* OK, inputs are all noncollatable */ ;
 				else if (inner_cxt.state != FDW_COLLATE_SAFE ||
 						 fe->inputcollid != inner_cxt.collation)
@@ -590,7 +590,7 @@ foreign_expr_walker(Node *node,
 				 * node might not care.)
 				 */
 				collation = fe->funccollid;
-				if (collation == InvalidOid)
+				if (!OidIsValid(collation))
 					state = FDW_COLLATE_NONE;
 				else if (inner_cxt.state == FDW_COLLATE_SAFE &&
 						 collation == inner_cxt.collation)
@@ -625,7 +625,7 @@ foreign_expr_walker(Node *node,
 				 * If operator's input collation is not derived from a foreign
 				 * Var, it can't be sent to remote.
 				 */
-				if (oe->inputcollid == InvalidOid)
+				if (!OidIsValid(oe->inputcollid))
 					 /* OK, inputs are all noncollatable */ ;
 				else if (inner_cxt.state != FDW_COLLATE_SAFE ||
 						 oe->inputcollid != inner_cxt.collation)
@@ -633,7 +633,7 @@ foreign_expr_walker(Node *node,
 
 				/* Result-collation handling is same as for functions */
 				collation = oe->opcollid;
-				if (collation == InvalidOid)
+				if (!OidIsValid(collation))
 					state = FDW_COLLATE_NONE;
 				else if (inner_cxt.state == FDW_COLLATE_SAFE &&
 						 collation == inner_cxt.collation)
@@ -665,7 +665,7 @@ foreign_expr_walker(Node *node,
 				 * If operator's input collation is not derived from a foreign
 				 * Var, it can't be sent to remote.
 				 */
-				if (oe->inputcollid == InvalidOid)
+				if (!OidIsValid(oe->inputcollid))
 					 /* OK, inputs are all noncollatable */ ;
 				else if (inner_cxt.state != FDW_COLLATE_SAFE ||
 						 oe->inputcollid != inner_cxt.collation)
@@ -692,7 +692,7 @@ foreign_expr_walker(Node *node,
 				 * an input foreign Var (same logic as for a real function).
 				 */
 				collation = r->resultcollid;
-				if (collation == InvalidOid)
+				if (!OidIsValid(collation))
 					state = FDW_COLLATE_NONE;
 				else if (inner_cxt.state == FDW_COLLATE_SAFE &&
 						 collation == inner_cxt.collation)
@@ -720,7 +720,7 @@ foreign_expr_walker(Node *node,
 				 * function).
 				 */
 				collation = e->resultcollid;
-				if (collation == InvalidOid)
+				if (!OidIsValid(collation))
 					state = FDW_COLLATE_NONE;
 				else if (inner_cxt.state == FDW_COLLATE_SAFE &&
 						 collation == inner_cxt.collation)
@@ -846,7 +846,7 @@ foreign_expr_walker(Node *node,
 				 * the THEN and ELSE subexpressions.
 				 */
 				collation = ce->casecollid;
-				if (collation == InvalidOid)
+				if (!OidIsValid(collation))
 					state = FDW_COLLATE_NONE;
 				else if (inner_cxt.state == FDW_COLLATE_SAFE &&
 						 collation == inner_cxt.collation)
@@ -871,7 +871,7 @@ foreign_expr_walker(Node *node,
 				 * the CASE arg.
 				 */
 				collation = c->collation;
-				if (collation == InvalidOid)
+				if (!OidIsValid(collation))
 					state = FDW_COLLATE_NONE;
 				else if (case_arg_cxt->state == FDW_COLLATE_SAFE &&
 						 collation == case_arg_cxt->collation)
@@ -898,7 +898,7 @@ foreign_expr_walker(Node *node,
 				 * an input foreign Var (same logic as for a function).
 				 */
 				collation = a->array_collid;
-				if (collation == InvalidOid)
+				if (!OidIsValid(collation))
 					state = FDW_COLLATE_NONE;
 				else if (inner_cxt.state == FDW_COLLATE_SAFE &&
 						 collation == inner_cxt.collation)
@@ -1010,7 +1010,7 @@ foreign_expr_walker(Node *node,
 				 * If aggregate's input collation is not derived from a
 				 * foreign Var, it can't be sent to remote.
 				 */
-				if (agg->inputcollid == InvalidOid)
+				if (!OidIsValid(agg->inputcollid))
 					 /* OK, inputs are all noncollatable */ ;
 				else if (inner_cxt.state != FDW_COLLATE_SAFE ||
 						 agg->inputcollid != inner_cxt.collation)
@@ -1023,7 +1023,7 @@ foreign_expr_walker(Node *node,
 				 * node might not care.)
 				 */
 				collation = agg->aggcollid;
-				if (collation == InvalidOid)
+				if (!OidIsValid(collation))
 					state = FDW_COLLATE_NONE;
 				else if (inner_cxt.state == FDW_COLLATE_SAFE &&
 						 collation == inner_cxt.collation)
diff --git a/src/backend/access/brin/brin.c b/src/backend/access/brin/brin.c
index 2f7d1437919..8d6ad686fbc 100644
--- a/src/backend/access/brin/brin.c
+++ b/src/backend/access/brin/brin.c
@@ -692,7 +692,7 @@ bringetbitmap(IndexScanDesc scan, TIDBitmap *tbm)
 		 * general, so this should be negligible, and repeated repalloc calls
 		 * are not free either.
 		 */
-		if (consistentFn[keyattno - 1].fn_oid == InvalidOid)
+		if (!OidIsValid(consistentFn->fn_oid))
 		{
 			FmgrInfo   *tmp;
 
diff --git a/src/backend/access/brin/brin_bloom.c b/src/backend/access/brin/brin_bloom.c
index 64dbb7b8532..1c91adbf708 100644
--- a/src/backend/access/brin/brin_bloom.c
+++ b/src/backend/access/brin/brin_bloom.c
@@ -726,7 +726,7 @@ bloom_get_procinfo(BrinDesc *bdesc, uint16 attno, uint16 procnum)
 	 */
 	opaque = (BloomOpaque *) bdesc->bd_info[attno - 1]->oi_opaque;
 
-	if (opaque->extra_procinfos[basenum].fn_oid == InvalidOid)
+	if (!OidIsValid(opaque->extra_procinfos[basenum].fn_oid))
 	{
 		if (RegProcedureIsValid(index_getprocid(bdesc->bd_index, attno,
 												procnum)))
diff --git a/src/backend/access/brin/brin_inclusion.c b/src/backend/access/brin/brin_inclusion.c
index b86ca5744a3..3a7317a843d 100644
--- a/src/backend/access/brin/brin_inclusion.c
+++ b/src/backend/access/brin/brin_inclusion.c
@@ -560,7 +560,7 @@ inclusion_get_procinfo(BrinDesc *bdesc, uint16 attno, uint16 procnum,
 	if (opaque->extra_proc_missing[basenum])
 		return NULL;
 
-	if (opaque->extra_procinfos[basenum].fn_oid == InvalidOid)
+	if (!OidIsValid(opaque->extra_procinfos[basenum].fn_oid))
 	{
 		if (RegProcedureIsValid(index_getprocid(bdesc->bd_index, attno,
 												procnum)))
@@ -629,7 +629,7 @@ inclusion_get_strategy_procinfo(BrinDesc *bdesc, uint16 attno, Oid subtype,
 		opaque->cached_subtype = subtype;
 	}
 
-	if (opaque->strategy_procinfos[strategynum - 1].fn_oid == InvalidOid)
+	if (!OidIsValid(opaque->strategy_procinfos[strategynum - 1].fn_oid))
 	{
 		Form_pg_attribute attr;
 		HeapTuple	tuple;
diff --git a/src/backend/access/brin/brin_minmax.c b/src/backend/access/brin/brin_minmax.c
index 79c5a0aa185..3744007be23 100644
--- a/src/backend/access/brin/brin_minmax.c
+++ b/src/backend/access/brin/brin_minmax.c
@@ -282,7 +282,7 @@ minmax_get_strategy_procinfo(BrinDesc *bdesc, uint16 attno, Oid subtype,
 		opaque->cached_subtype = subtype;
 	}
 
-	if (opaque->strategy_procinfos[strategynum - 1].fn_oid == InvalidOid)
+	if (!OidIsValid(opaque->strategy_procinfos[strategynum - 1].fn_oid))
 	{
 		Form_pg_attribute attr;
 		HeapTuple	tuple;
diff --git a/src/backend/access/brin/brin_minmax_multi.c b/src/backend/access/brin/brin_minmax_multi.c
index f8a11444d66..e5207e1ee9f 100644
--- a/src/backend/access/brin/brin_minmax_multi.c
+++ b/src/backend/access/brin/brin_minmax_multi.c
@@ -303,7 +303,7 @@ AssertCheckRanges(Ranges *ranges, FmgrInfo *cmpFn, Oid colloid)
 	Assert(ranges->nsorted >= 0);
 	Assert(ranges->nvalues >= ranges->nsorted);
 	Assert(ranges->maxvalues >= 2 * ranges->nranges + ranges->nvalues);
-	Assert(ranges->typid != InvalidOid);
+	Assert(OidIsValid(ranges->typid));
 
 	/*
 	 * First the ranges - there are 2*nranges boundary values, and the values
@@ -2871,7 +2871,7 @@ minmax_multi_get_procinfo(BrinDesc *bdesc, uint16 attno, uint16 procnum)
 	 */
 	opaque = (MinmaxMultiOpaque *) bdesc->bd_info[attno - 1]->oi_opaque;
 
-	if (opaque->extra_procinfos[basenum].fn_oid == InvalidOid)
+	if (!OidIsValid(opaque->extra_procinfos[basenum].fn_oid))
 	{
 		if (RegProcedureIsValid(index_getprocid(bdesc->bd_index, attno,
 												procnum)))
@@ -2920,7 +2920,7 @@ minmax_multi_get_strategy_procinfo(BrinDesc *bdesc, uint16 attno, Oid subtype,
 		opaque->cached_subtype = subtype;
 	}
 
-	if (opaque->strategy_procinfos[strategynum - 1].fn_oid == InvalidOid)
+	if (!OidIsValid(opaque->strategy_procinfos[strategynum - 1].fn_oid))
 	{
 		Form_pg_attribute attr;
 		HeapTuple	tuple;
diff --git a/src/backend/access/common/toast_internals.c b/src/backend/access/common/toast_internals.c
index 81dbd67c725..69ee1267b34 100644
--- a/src/backend/access/common/toast_internals.c
+++ b/src/backend/access/common/toast_internals.c
@@ -260,7 +260,7 @@ toast_save_datum(Relation rel, Datum value,
 				}
 			}
 		}
-		if (toast_pointer.va_valueid == InvalidOid)
+		if (!OidIsValid(toast_pointer.va_valueid))
 		{
 			/*
 			 * new value; must choose an OID that doesn't conflict in either
diff --git a/src/backend/access/gin/gininsert.c b/src/backend/access/gin/gininsert.c
index c2b879b2bf6..512bd403680 100644
--- a/src/backend/access/gin/gininsert.c
+++ b/src/backend/access/gin/gininsert.c
@@ -1302,7 +1302,7 @@ GinBufferInit(Relation index)
 		 * up the index key type's default btree comparator.
 		 */
 		cmpFunc = index_getprocid(index, i + 1, GIN_COMPARE_PROC);
-		if (cmpFunc == InvalidOid)
+		if (!OidIsValid(cmpFunc))
 		{
 			TypeCacheEntry *typentry;
 
diff --git a/src/backend/access/gin/ginutil.c b/src/backend/access/gin/ginutil.c
index 49631200a5a..5abca6d750d 100644
--- a/src/backend/access/gin/ginutil.c
+++ b/src/backend/access/gin/ginutil.c
@@ -182,8 +182,8 @@ initGinState(GinState *state, Relation index)
 						   CurrentMemoryContext);
 		}
 
-		if (state->consistentFn[i].fn_oid == InvalidOid &&
-			state->triConsistentFn[i].fn_oid == InvalidOid)
+		if (!OidIsValid(state->consistentFn[i].fn_oid) &&
+			!OidIsValid(state->triConsistentFn[i].fn_oid))
 		{
 			elog(ERROR, "missing GIN support function (%d or %d) for attribute %d of index \"%s\"",
 				 GIN_CONSISTENT_PROC, GIN_TRICONSISTENT_PROC,
diff --git a/src/backend/access/gist/gistutil.c b/src/backend/access/gist/gistutil.c
index 75272827837..cfda8b0f2e4 100644
--- a/src/backend/access/gist/gistutil.c
+++ b/src/backend/access/gist/gistutil.c
@@ -677,14 +677,14 @@ gistFetchTuple(GISTSTATE *giststate, Relation r, IndexTuple tuple)
 
 		datum = index_getattr(tuple, i + 1, giststate->leafTupdesc, &isnull[i]);
 
-		if (giststate->fetchFn[i].fn_oid != InvalidOid)
+		if (OidIsValid(giststate->fetchFn[i].fn_oid))
 		{
 			if (!isnull[i])
 				fetchatt[i] = gistFetchAtt(giststate, i, datum, r);
 			else
 				fetchatt[i] = (Datum) 0;
 		}
-		else if (giststate->compressFn[i].fn_oid == InvalidOid)
+		else if (!OidIsValid(giststate->compressFn[i].fn_oid))
 		{
 			/*
 			 * If opclass does not provide compress method that could change
diff --git a/src/backend/access/hash/hashfunc.c b/src/backend/access/hash/hashfunc.c
index ec96348942e..211eca234ff 100644
--- a/src/backend/access/hash/hashfunc.c
+++ b/src/backend/access/hash/hashfunc.c
@@ -271,7 +271,7 @@ hashtext(PG_FUNCTION_ARGS)
 	pg_locale_t mylocale;
 	Datum		result;
 
-	if (!collid)
+	if (!OidIsValid(collid))
 		ereport(ERROR,
 				(errcode(ERRCODE_INDETERMINATE_COLLATION),
 				 errmsg("could not determine which collation to use for string hashing"),
@@ -326,7 +326,7 @@ hashtextextended(PG_FUNCTION_ARGS)
 	pg_locale_t mylocale;
 	Datum		result;
 
-	if (!collid)
+	if (!OidIsValid(collid))
 		ereport(ERROR,
 				(errcode(ERRCODE_INDETERMINATE_COLLATION),
 				 errmsg("could not determine which collation to use for string hashing"),
diff --git a/src/backend/access/hash/hashsearch.c b/src/backend/access/hash/hashsearch.c
index 92c15a65be2..4559978c725 100644
--- a/src/backend/access/hash/hashsearch.c
+++ b/src/backend/access/hash/hashsearch.c
@@ -338,7 +338,7 @@ _hash_first(IndexScanDesc scan, ScanDirection dir)
 	 * opclass input type; this is a hack to simplify life for ScanKeyInit().
 	 */
 	if (cur->sk_subtype == rel->rd_opcintype[0] ||
-		cur->sk_subtype == InvalidOid)
+		!OidIsValid(cur->sk_subtype))
 		hashkey = _hash_datum2hashkey(rel, cur->sk_argument);
 	else
 		hashkey = _hash_datum2hashkey_type(rel, cur->sk_argument,
diff --git a/src/backend/access/heap/heapam.c b/src/backend/access/heap/heapam.c
index 4b0c49f4bb0..c9ebd0e4ced 100644
--- a/src/backend/access/heap/heapam.c
+++ b/src/backend/access/heap/heapam.c
@@ -9076,7 +9076,7 @@ log_heap_new_cid(Relation relation, HeapTuple tup)
 	HeapTupleHeader hdr = tup->t_data;
 
 	Assert(ItemPointerIsValid(&tup->t_self));
-	Assert(tup->t_tableOid != InvalidOid);
+	Assert(OidIsValid(tup->t_tableOid));
 
 	xlrec.top_xid = GetTopTransactionId();
 	xlrec.target_locator = relation->rd_locator;
diff --git a/src/backend/access/heap/heapam_visibility.c b/src/backend/access/heap/heapam_visibility.c
index 05f6946fe60..9c8e20a4256 100644
--- a/src/backend/access/heap/heapam_visibility.c
+++ b/src/backend/access/heap/heapam_visibility.c
@@ -172,7 +172,7 @@ HeapTupleSatisfiesSelf(HeapTuple htup, Snapshot snapshot, Buffer buffer)
 	HeapTupleHeader tuple = htup->t_data;
 
 	Assert(ItemPointerIsValid(&htup->t_self));
-	Assert(htup->t_tableOid != InvalidOid);
+	Assert(OidIsValid(htup->t_tableOid));
 
 	if (!HeapTupleHeaderXminCommitted(tuple))
 	{
@@ -365,7 +365,7 @@ HeapTupleSatisfiesToast(HeapTuple htup, Snapshot snapshot,
 	HeapTupleHeader tuple = htup->t_data;
 
 	Assert(ItemPointerIsValid(&htup->t_self));
-	Assert(htup->t_tableOid != InvalidOid);
+	Assert(OidIsValid(htup->t_tableOid));
 
 	if (!HeapTupleHeaderXminCommitted(tuple))
 	{
@@ -461,7 +461,7 @@ HeapTupleSatisfiesUpdate(HeapTuple htup, CommandId curcid,
 	HeapTupleHeader tuple = htup->t_data;
 
 	Assert(ItemPointerIsValid(&htup->t_self));
-	Assert(htup->t_tableOid != InvalidOid);
+	Assert(OidIsValid(htup->t_tableOid));
 
 	if (!HeapTupleHeaderXminCommitted(tuple))
 	{
@@ -746,7 +746,7 @@ HeapTupleSatisfiesDirty(HeapTuple htup, Snapshot snapshot,
 	HeapTupleHeader tuple = htup->t_data;
 
 	Assert(ItemPointerIsValid(&htup->t_self));
-	Assert(htup->t_tableOid != InvalidOid);
+	Assert(OidIsValid(htup->t_tableOid));
 
 	snapshot->xmin = snapshot->xmax = InvalidTransactionId;
 	snapshot->speculativeToken = 0;
@@ -972,7 +972,7 @@ HeapTupleSatisfiesMVCC(HeapTuple htup, Snapshot snapshot,
 	Assert(snapshot->regd_count > 0 || snapshot->active_count > 0);
 
 	Assert(ItemPointerIsValid(&htup->t_self));
-	Assert(htup->t_tableOid != InvalidOid);
+	Assert(OidIsValid(htup->t_tableOid));
 
 	if (!HeapTupleHeaderXminCommitted(tuple))
 	{
@@ -1207,7 +1207,7 @@ HeapTupleSatisfiesVacuumHorizon(HeapTuple htup, Buffer buffer, TransactionId *de
 	HeapTupleHeader tuple = htup->t_data;
 
 	Assert(ItemPointerIsValid(&htup->t_self));
-	Assert(htup->t_tableOid != InvalidOid);
+	Assert(OidIsValid(htup->t_tableOid));
 	Assert(dead_after != NULL);
 
 	*dead_after = InvalidTransactionId;
@@ -1476,7 +1476,7 @@ HeapTupleIsSurelyDead(HeapTuple htup, GlobalVisState *vistest)
 	HeapTupleHeader tuple = htup->t_data;
 
 	Assert(ItemPointerIsValid(&htup->t_self));
-	Assert(htup->t_tableOid != InvalidOid);
+	Assert(OidIsValid(htup->t_tableOid));
 
 	/*
 	 * If the inserting transaction is marked invalid, then it aborted, and
@@ -1601,7 +1601,7 @@ HeapTupleSatisfiesHistoricMVCC(HeapTuple htup, Snapshot snapshot,
 	TransactionId xmax = HeapTupleHeaderGetRawXmax(tuple);
 
 	Assert(ItemPointerIsValid(&htup->t_self));
-	Assert(htup->t_tableOid != InvalidOid);
+	Assert(OidIsValid(htup->t_tableOid));
 
 	/* inserting transaction aborted */
 	if (HeapTupleHeaderXminInvalid(tuple))
diff --git a/src/backend/access/index/indexam.c b/src/backend/access/index/indexam.c
index 0492d92d23b..fb51cde5a6d 100644
--- a/src/backend/access/index/indexam.c
+++ b/src/backend/access/index/indexam.c
@@ -937,7 +937,7 @@ index_getprocinfo(Relation irel,
 	locinfo += procindex;
 
 	/* Initialize the lookup info if first time through */
-	if (locinfo->fn_oid == InvalidOid)
+	if (!OidIsValid(locinfo->fn_oid))
 	{
 		RegProcedure *loc = irel->rd_support;
 		RegProcedure procId;
diff --git a/src/backend/access/nbtree/nbtcompare.c b/src/backend/access/nbtree/nbtcompare.c
index 188c27b4925..0f852833708 100644
--- a/src/backend/access/nbtree/nbtcompare.c
+++ b/src/backend/access/nbtree/nbtcompare.c
@@ -458,7 +458,7 @@ oid_decrement(Relation rel, Datum existing, bool *underflow)
 {
 	Oid			oexisting = DatumGetObjectId(existing);
 
-	if (oexisting == InvalidOid)
+	if (!OidIsValid(oexisting))
 	{
 		/* return value is undefined */
 		*underflow = true;
diff --git a/src/backend/access/nbtree/nbtpreprocesskeys.c b/src/backend/access/nbtree/nbtpreprocesskeys.c
index a871bf62cab..d03d9e4ebc7 100644
--- a/src/backend/access/nbtree/nbtpreprocesskeys.c
+++ b/src/backend/access/nbtree/nbtpreprocesskeys.c
@@ -1013,13 +1013,13 @@ _bt_compare_scankey_args(IndexScanDesc scan, ScanKey op,
 	 * input type; this is a hack to simplify life for ScanKeyInit().
 	 */
 	lefttype = leftarg->sk_subtype;
-	if (lefttype == InvalidOid)
+	if (!OidIsValid(lefttype))
 		lefttype = opcintype;
 	righttype = rightarg->sk_subtype;
-	if (righttype == InvalidOid)
+	if (!OidIsValid(righttype))
 		righttype = opcintype;
 	optype = op->sk_subtype;
-	if (optype == InvalidOid)
+	if (!OidIsValid(optype))
 		optype = opcintype;
 
 	/*
@@ -1150,7 +1150,7 @@ _bt_saoparray_shrink(IndexScanDesc scan, ScanKey arraysk, ScanKey skey,
 	 * means the opclass input type; this is a hack to simplify life for
 	 * ScanKeyInit().
 	 */
-	if (skey->sk_subtype != opcintype && skey->sk_subtype != InvalidOid)
+	if (skey->sk_subtype != opcintype && OidIsValid(skey->sk_subtype))
 	{
 		RegProcedure cmp_proc;
 		Oid			arraysk_elemtype;
@@ -1163,7 +1163,7 @@ _bt_saoparray_shrink(IndexScanDesc scan, ScanKey arraysk, ScanKey skey,
 		 * as its tupdatum/lefthand argument (rhs arg is for array elements).
 		 */
 		arraysk_elemtype = arraysk->sk_subtype;
-		if (arraysk_elemtype == InvalidOid)
+		if (!OidIsValid(arraysk_elemtype))
 			arraysk_elemtype = rel->rd_opcintype[arraysk->sk_attno - 1];
 		cmp_proc = get_opfamily_proc(rel->rd_opfamily[arraysk->sk_attno - 1],
 									 skey->sk_subtype, arraysk_elemtype,
@@ -1421,7 +1421,7 @@ _bt_skiparray_strat_decrement(IndexScanDesc scan, ScanKey arraysk,
 	 * index attribute's input opclass type
 	 */
 	if (high_compare->sk_subtype != opcintype &&
-		high_compare->sk_subtype != InvalidOid)
+		OidIsValid(high_compare->sk_subtype))
 		return;
 
 	/* Decrement, handling underflow by marking the qual unsatisfiable */
@@ -1479,7 +1479,7 @@ _bt_skiparray_strat_increment(IndexScanDesc scan, ScanKey arraysk,
 	 * index attribute's input opclass type
 	 */
 	if (low_compare->sk_subtype != opcintype &&
-		low_compare->sk_subtype != InvalidOid)
+		OidIsValid(low_compare->sk_subtype))
 		return;
 
 	/* Increment, handling overflow by marking the qual unsatisfiable */
@@ -2053,7 +2053,7 @@ _bt_preprocess_array_keys(IndexScanDesc scan, int *new_numberOfKeys)
 		 * ScanKeyInit().
 		 */
 		elemtype = cur->sk_subtype;
-		if (elemtype == InvalidOid)
+		if (!OidIsValid(elemtype))
 			elemtype = rel->rd_opcintype[cur->sk_attno - 1];
 
 		/*
@@ -2266,7 +2266,7 @@ _bt_preprocess_array_keys_final(IndexScanDesc scan, int *keyDataMap)
 				continue;
 
 			elemtype = outkey->sk_subtype;
-			if (elemtype == InvalidOid)
+			if (!OidIsValid(elemtype))
 				elemtype = rel->rd_opcintype[outkey->sk_attno - 1];
 
 			_bt_setup_array_cmp(scan, outkey, elemtype,
